unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ComCtrls, Menus, StdCtrls, Buttons, Grids;

type
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    Saveas1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Help0: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Pan: TPanel;
    Timer: TTimer;
    Bevel: TBevel;
    View1: TMenuItem;
    ShowSpin: TMenuItem;
    Panel1: TPanel;
    DaoTeta1: TSpeedButton;
    DaoStop: TSpeedButton;
    DaoPsi: TSpeedButton;
    DaoPsi1: TSpeedButton;
    DaoTeta: TSpeedButton;
    DaoPhi1: TSpeedButton;
    DaoPhi: TSpeedButton;
    DaoForvard: TSpeedButton;
    DaoBack: TSpeedButton;
    TrackBar: TTrackBar;
    ShowNumbersOfPoints: TMenuItem;
    Images: TMenuItem;
    Daons1: TMenuItem;
    Spiral1: TMenuItem;
    Manager1: TMenuItem;
    Left1: TMenuItem;
    Right1: TMenuItem;
    Up1: TMenuItem;
    Down1: TMenuItem;
    Go: TBitBtn;
    ShapeLime: TShape;
    ShapeRed: TShape;
    LTime: TLabel;
    Label1: TLabel;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    MoveToCenter: TMenuItem;
    FName: TEdit;
    PageControl: TPageControl;
    TabSheet1: TTabSheet;
    DaonsTable: TStringGrid;
    RusHelp: TMenuItem;
    PolHelp: TMenuItem;
    TabSheet2: TTabSheet;
    Comment: TMemo;
    ShowList: TCheckBox;
    EditDT: TEdit;
    DtLabel: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    EditA1: TEdit;
    EditB1: TEdit;
    EditA2: TEdit;
    EditB2: TEdit;
    Edit1: TEdit;
    Edit2: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    CheckBox3: TCheckBox;
    Label2: TLabel;
    EditA3: TEdit;
    EditB3: TEdit;
    EditC3: TEdit;
    Label3: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Edit3: TEdit;
    Blockade: TCheckBox;
    EditC2: TEdit;
    Label12: TLabel;
    EditD3: TEdit;
    Label13: TLabel;
    EditD2: TEdit;
    Label14: TLabel;
    Taoscope: TRadioButton;
    Gravoscope: TRadioButton;
    CheckBox4: TCheckBox;
    procedure Exit1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ShowSpinClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure DaoTeta1Click(Sender: TObject);
    procedure DaoTetaClick(Sender: TObject);
    procedure DaoPsiClick(Sender: TObject);
    procedure DaoPsi1Click(Sender: TObject);
    procedure DaoStopClick(Sender: TObject);
    procedure DaoPhi1Click(Sender: TObject);
    procedure DaoPhiClick(Sender: TObject);
    procedure DaoBackClick(Sender: TObject);
    procedure DaoForvardClick(Sender: TObject);
    procedure TrackBarChange(Sender: TObject);
    procedure ShowNumbersOfPointsClick(Sender: TObject);
    procedure Spiral1Click(Sender: TObject);
    procedure Daons1Click(Sender: TObject);
    procedure Left1Click(Sender: TObject);
    procedure Right1Click(Sender: TObject);
    procedure Up1Click(Sender: TObject);
    procedure Down1Click(Sender: TObject);
    procedure GoClick(Sender: TObject);
    procedure DaonsTableDblClick(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Saveas1Click(Sender: TObject);
    procedure MoveToCenterClick(Sender: TObject);
    procedure CommentChange(Sender: TObject);
    procedure CommentExit(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure RusHelpClick(Sender: TObject);
    procedure PolHelpClick(Sender: TObject);
    procedure EditDTKeyPress(Sender: TObject; var Key: Char);
    procedure EditDTExit(Sender: TObject);
    procedure EditCzasKeyPress(Sender: TObject; var Key: Char);
    procedure EditA1Exit(Sender: TObject);
    procedure EditB1Exit(Sender: TObject);
    procedure EditA2Exit(Sender: TObject);
    procedure EditB2Exit(Sender: TObject);
    procedure EditC2Exit(Sender: TObject);
    procedure EditD2Exit(Sender: TObject);
    procedure EditA3Exit(Sender: TObject);
    procedure EditB3Exit(Sender: TObject);
    procedure EditC3Exit(Sender: TObject);
    procedure EditD3Exit(Sender: TObject);

    procedure Null00Click(Sender: TObject);
    procedure LTimeDblClick(Sender: TObject);
    procedure EditA1KeyPress(Sender: TObject; var Key: Char);
    procedure EditB1KeyPress(Sender: TObject; var Key: Char);
    procedure EditA2KeyPress(Sender: TObject; var Key: Char);
    procedure EditB2KeyPress(Sender: TObject; var Key: Char);
    procedure EditC2KeyPress(Sender: TObject; var Key: Char);
    procedure EditD2KeyPress(Sender: TObject; var Key: Char);
    procedure EditA3KeyPress(Sender: TObject; var Key: Char);
    procedure EditB3KeyPress(Sender: TObject; var Key: Char);
    procedure EditC3KeyPress(Sender: TObject; var Key: Char);
    procedure EditD3KeyPress(Sender: TObject; var Key: Char);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$N+}

uses Global, Figures, Edit, About;

{$R *.DFM}

var
   //Power,             // Type of formula
   ShowLabelTime,
   EditComm,          // Comment is changed
   ShowNumbersOfPunkts,
   VeloCity,
   Spin               // Spin
                      :boolean;
   LStartX,LStartY,
   RStartX,RStartY
                      :integer;
   KoBok,             //  
   KoRass,            // Koeff for length
   KoUgol             // Koeff
                      :extended;

procedure ClearCub;
begin
     with MainForm do
     with Canvas do
          begin
          Pen.Color:=clBlack;Brush.Color:=clBlack;
          Rectangle(Bevel.Left,Bevel.Top,Width,Pan.Top);
          end;
end;

procedure ShowTable;
var ii,jj:integer;
begin
with MainForm do
     with DaonsTable do
     if not VeloCity
     then
     begin
     Cells[1,0]:='X';Cells[2,0]:='Y';Cells[3,0]:='Z';
     for jj:=1 to MaxTaons do
         Cells[0,jj]:=IntToStr(jj);

     for ii := 1 to MaxTaons do
     for jj:= 1 to RowCount do
     if Dao[ii]
        then
        case jj of
         1:Cells[jj,ii] := FloatToStr(Xo[ii]);
         2:Cells[jj,ii] := FloatToStr(Yo[ii]);
         3:Cells[jj,ii] := FloatToStr(Zo[ii]);
        end
        else
            Cells[jj,ii] := '';
     end
     else
     begin
     Cells[1,0]:='u(x)';Cells[2,0]:='u(y)';Cells[3,0]:='u(z)';
     for jj:=1 to MaxTaons do
         Cells[0,jj]:=IntToStr(jj);

     for ii := 1 to MaxTaons do
     for jj:= 1 to RowCount do
     if Dao[ii]
        then
        case jj of
         1:Cells[jj,ii] := FloatToStr(Vo[ii]);
         2:Cells[jj,ii] := FloatToStr(Uo[ii]);
         3:Cells[jj,ii] := FloatToStr(Wo[ii]);
         end
        else
            Cells[jj,ii] := '';
     end;
end;

procedure DrawLine;
var n             :integer;
begin
Ffsincos;
  for n:=1 to MaxTaons do
  if Dao[n] then
    begin
          q:=f11*x[n]+f12*y[n]+f13*z[n];
          w:=f21*x[n]+f22*y[n]+f23*z[n];
          e:=f31*x[n]+f32*y[n]+f33*z[n];
          xs[n]:=q;ys[n]:=w;zs[n]:=e;
          xp:=xs[n]*xl/2;
          yp:=ys[n]*xl/2;
          zp:=zs[n]*xl/2;
          uu:=xp+u0+xt;
          vv:=zp+v0+zt;
          u[n]:=round(uu);v[n]:=round(vv);
    end;

ClearCub;

with MainForm do
     with Canvas do
          begin
             for n:=1 to MaxTaons do
                 if MainForm.Taoscope.Checked then
                     if Dao[n] then
                        begin
                          if Odd(n) then
                          begin
                          Pixels[u[n],v[n]]:=clRed;   //Fuchsia
                          Pixels[u[n]+1,v[n]]:=clRed;
                          Pixels[u[n],v[n]+1]:=clRed;
                          Pixels[u[n]+1,v[n]+1]:=clRed;
                          end
                          else
                          begin
                          Pixels[u[n],v[n]]:=clLime;  //Aqua;
                          Pixels[u[n]+1,v[n]]:=clLime;
                          Pixels[u[n],v[n]+1]:=clLime;
                          Pixels[u[n]+1,v[n]+1]:=clLime;
                          end;
                       end;
                 if MainForm.Gravoscope.Checked then
                   for n:=1 to MaxTaons do
                     if Dao[n] then
                       begin
                          if (n<=(MaxTaons-40)) then
                         begin
                          Pixels[u[n],v[n]]:=clYellow;
                          Pixels[u[n]+1,v[n]]:=clYellow;
                          Pixels[u[n],v[n]+1]:=clYellow;
                          Pixels[u[n]+1,v[n]+1]:=clYellow;
                         end;
                          if ((n>(MaxTaons-40)) and (n<=(MaxTaons-20))) then
                         begin
                          Pixels[u[n],v[n]]:=clFuchsia;
                          Pixels[u[n]+1,v[n]]:=clFuchsia;
                          Pixels[u[n],v[n]+1]:=clFuchsia;
                          Pixels[u[n]+1,v[n]+1]:=clFuchsia;
                         end;
                          if (n>(MaxTaons-20)) then
                         begin
                          Pixels[u[n],v[n]]:=clAqua;
                          Pixels[u[n]+1,v[n]]:=clAqua;
                          Pixels[u[n],v[n]+1]:=clAqua;
                          Pixels[u[n]+1,v[n]+1]:=clAqua;
                         end;
                       end;
                 if MainForm.Taoscope.Checked then
                   if ShowNumbersOfPunkts then
                     for n:=1 to MaxTaons do
                     if Dao[n] then
                       begin
                         if Odd(n) then
                         Font.Color:=clRed
                         else
                         Font.Color:=clLime;
                         TextOut(u[n]+2,v[n]+2,IntToStr(n));
                       end;
             if MainForm.Gravoscope.Checked then
                if ShowNumbersOfPunkts then
                   for n:=1 to MaxTaons do
                     if Dao[n] then
                       begin
                         if (n<=(MaxTaons-40)) then
                         Font.Color:=clYellow;
                         if ((n>(MaxTaons-40)) and (n<=(MaxTaons-20))) then
                         Font.Color:=clFuchsia;
                         if (n>(MaxTaons-20)) then
                         Font.Color:=clAqua;
                         TextOut(u[n]+2,v[n]+2,IntToStr(n));
                       end;
                       
          end;
end;
procedure ShowSpiral;
  procedure Proection(Maxn:integer);
  var n:integer;
  begin
  for n:=1 to Maxn do
      begin
          q:=f11*x[n]+f12*y[n]+f13*z[n];
          w:=f21*x[n]+f22*y[n]+f23*z[n];
          e:=f31*x[n]+f32*y[n]+f33*z[n];
          x[n]:=q;y[n]:=w;z[n]:=e;
          xp:=x[n]*xl/2;
          yp:=y[n]*xl/2;
          zp:=z[n]*xl/2;
          uu:=xp+u0+xt;
          vv:=zp+v0+zt;
          u[n]:=round(uu);v[n]:=round(vv);
      end;
  end;//Proection
begin
fsincos;
ClearCub;
with MainForm do
     with Canvas do
     case TypeSpiral of
     0:;
     1:
          begin
          Proection(19);
          Pen.Color:=clWhite;
          // first triangle
          moveto(u[1],v[1]);lineto(u[2],v[2]); // Axis
          Pen.Color:=clRed;
          lineto(u[3],v[3]);
          lineto(u[1],v[1]);
          // Tetra
          moveto(u[1],v[1]);lineto(u[4],v[4]);
          moveto(u[2],v[2]);lineto(u[4],v[4]);
          lineto(u[3],v[3]);lineto(u[4],v[4]);
          // 2-Tetra
          moveto(u[1],v[1]);lineto(u[5],v[5]);
          moveto(u[2],v[2]);lineto(u[5],v[5]);
          lineto(u[3],v[3]);lineto(u[5],v[5]);
          // 3-Tetra
          moveto(u[1],v[1]);lineto(u[6],v[6]);
          moveto(u[2],v[2]);lineto(u[6],v[6]);
          lineto(u[6],v[6]);lineto(u[5],v[5]);
          // 4-Tetra
          moveto(u[1],v[1]);lineto(u[7],v[7]);
          moveto(u[2],v[2]);lineto(u[7],v[7]);
          lineto(u[7],v[7]);lineto(u[6],v[6]);
          // 5-Tetra
          moveto(u[2],v[2]);lineto(u[8],v[8]);
          moveto(u[6],v[6]);lineto(u[8],v[8]);
          lineto(u[7],v[7]);lineto(u[8],v[8]);
          // 6-Tetra
          moveto(u[2],v[2]);lineto(u[9],v[9]);
          moveto(u[6],v[6]);lineto(u[9],v[9]);
          lineto(u[8],v[8]);lineto(u[9],v[9]);
          // 7-Tetra
          Pen.Color:=clWhite;  // Axis
          moveto(u[2],v[2]);lineto(u[10],v[10]);
          Pen.Color:=clRed;
          moveto(u[8],v[8]);lineto(u[10],v[10]);
          lineto(u[9],v[9]);lineto(u[10],v[10]);
          // 8-Tetra
          moveto(u[2],v[2]);lineto(u[11],v[11]);
          moveto(u[8],v[8]);lineto(u[11],v[11]);
          lineto(u[10],v[10]);lineto(u[11],v[11]);
          // 9-Tetra
          moveto(u[2],v[2]);lineto(u[12],v[12]);
          moveto(u[10],v[10]);lineto(u[12],v[12]);
          lineto(u[11],v[11]);lineto(u[12],v[12]);
          // 10-Tetra
          moveto(u[2],v[2]);lineto(u[13],v[13]);
          moveto(u[10],v[10]);lineto(u[13],v[13]);
          lineto(u[12],v[12]);lineto(u[13],v[13]);
          // 11-Tetra
          moveto(u[10],v[10]);lineto(u[14],v[14]);
          moveto(u[12],v[12]);lineto(u[14],v[14]);
          lineto(u[13],v[13]);lineto(u[14],v[14]);
          // 12-Tetra
          moveto(u[10],v[10]);lineto(u[15],v[15]);
          moveto(u[12],v[12]);lineto(u[15],v[15]);
          lineto(u[14],v[14]);lineto(u[15],v[15]);
          // 13-Tetra
          Pen.Color:=clWhite;  // Axis
          moveto(u[10],v[10]);lineto(u[16],v[16]);
          Pen.Color:=clRed;
          moveto(u[14],v[14]);lineto(u[16],v[16]);
          lineto(u[15],v[15]);lineto(u[16],v[16]);
          // 14-Tetra
          moveto(u[10],v[10]);lineto(u[17],v[17]);
          moveto(u[14],v[14]);lineto(u[17],v[17]);
          lineto(u[16],v[16]);lineto(u[17],v[17]);
          // 15-Tetra
          moveto(u[10],v[10]);lineto(u[18],v[18]);
          moveto(u[16],v[16]);lineto(u[18],v[18]);
          lineto(u[17],v[17]);lineto(u[18],v[18]);
          // 16-Tetra
          moveto(u[10],v[10]);lineto(u[19],v[19]);
          moveto(u[16],v[16]);lineto(u[19],v[19]);
          lineto(u[18],v[18]);lineto(u[19],v[19]);

          if ShowNumbersOfPunkts then
             begin
             Font.Color:=clLime;
             TextOut(u[1],v[1],'1');
             TextOut(u[2],v[2],'2');
             TextOut(u[3],v[3],'3');
             TextOut(u[4],v[4],'4');
             TextOut(u[5],v[5],'5');
             TextOut(u[6],v[6],'6');
             TextOut(u[7],v[7],'7');
             TextOut(u[8],v[8],'8');
             TextOut(u[9],v[9],'9');
             TextOut(u[10],v[10],'10');
             TextOut(u[11],v[11],'11');
             TextOut(u[12],v[12],'12');
             TextOut(u[13],v[13],'13');
             TextOut(u[14],v[14],'14');
             TextOut(u[15],v[15],'15');
             TextOut(u[16],v[16],'16');
             TextOut(u[17],v[17],'17');
             TextOut(u[18],v[18],'18');
             TextOut(u[19],v[19],'19');
             end;
          end;
     2:;
     3:;
     end;//case
end;//ShowSpiral

procedure Game(Num:Longint);
var
   i                    // Number of partikle
                          :Longint;

   dXv, dYv, dZv,         // Prirashenie skorosti
   dX, dY, dZ, Cz             // Prirashenie koordinat
                          :extended;

   function GT :integer;
           begin
                if MainForm.Taoscope.Checked
                then
                GT:=1
                else
                GT:=-1;
           end;
function Minus(im,jm:integer):integer;
   begin
     if Odd(im-jm) then
     Minus :=-1*GT
     else
     Minus := 1
end;
function XUsko(im:integer):extended;
   // Poluchaem uskorenie po osi X
   var j :integer;
       Xia :extended;
       pa23,pb2,pc2,pd2,pb3,pc3,pd3,s :extended;
   begin //1
   Xia:=0;

   for j:=1 to MaxTaons do
    if Dao[j] then
     if j<>i then
      begin //2
      s := Sqrt(Sqr(Xo[i]-Xo[j])+Sqr(Yo[i]-Yo[j])+Sqr(Zo[i]-Zo[j]));

      pa23:=-GT*(0.945/0.1)*St(18,(0.945/0.1)*s)* (1+19*ln((0.945/0.1)*s))*St(-St(19,(0.945/0.1)*s),(0.945/0.1)*s)
      -125*St(-14,10)*(2.7/30)*75*St(-2,(2.7/30)*s)*(1-ln((2.7/30)*s))*St(75*St(-1,(2.7/30)*s),(2.7/30)*s);

      pb2:=-( St(-1,0.1*1.029/B2)* St(-2,s)*(2.5- St(20,1.029/B2*s))*(1-ln(1.029/B2*s))-200*1.029/B2*St(18,1.029/B2*s)
      *ln(1.029/B2*s))*St((2.5-St(20,1.029/B2*s))*St(-1,0.1*1.029/B2*s),1.029/B2*s);
      pc2:=-( St(-1,0.1*1.029/C2)* St(-2,s)*(2.5- St(20,1.029/C2*s))*(1-ln(1.029/C2*s))-200*1.029/C2*St(18,1.029/C2*s)
      *ln(1.029/C2*s))*St((2.5-St(20,1.029/C2*s))*St(-1,0.1*1.029/C2*s),1.029/C2*s);
      pd2:=-( St(-1,0.1*1.029/D2)* St(-2,s)*(2.5- St(20,1.029/D2*s))*(1-ln(1.029/D2*s))-200*1.029/D2*St(18,1.029/D2*s)
      *ln(1.029/D2*s))*St((2.5-St(20,1.029/D2*s))*St(-1,0.1*1.029/D2*s),1.029/D2*s);

      pb3:=-( St(-1,0.1*1.029/B3)* St(-2,s)*(2.5- St(20,1.029/B3*s))*(1-ln(1.029/B3*s))-200*1.029/B3*St(18,1.029/B3*s)
      *ln(1.029/B3*s))*St((2.5-St(20,1.029/B3*s))*St(-1,0.1*1.029/B3*s),1.029/B3*s);
      pc3:=-( St(-1,0.1*1.029/C3)* St(-2,s)*(2.5- St(20,1.029/C3*s))*(1-ln(1.029/C3*s))-200*1.029/C3*St(18,1.029/C3*s)
      *ln(1.029/C3*s))*St((2.5-St(20,1.029/C3*s))*St(-1,0.1*1.029/C3*s),1.029/C3*s);
      pd3:=-( St(-1,0.1*1.029/D3)* St(-2,s)*(2.5- St(20,1.029/D3*s))*(1-ln(1.029/D3*s))-200*1.029/D3*St(18,1.029/D3*s)
      *ln(1.029/D3*s))*St((2.5-St(20,1.029/D3*s))*St(-1,0.1*1.029/D3*s),1.029/D3*s);

       begin   //3
           if (j<=(MaxTaons-40)) then
            if MainForm.CheckBox1.Checked then
            Xia := Xia
            else
            begin
           if MainForm.CheckBox4.Checked then
            Xia := Xia -
            GT*Minus(i,j) * (Xo[i]-Xo[j])/s *St(-2,s)*
            A1 * B1 *St(B1 / s,s) *(1-ln(s))
            else
            Xia := Xia +
            GT*Minus(i,j) * (Xo[i]-Xo[j])/s *St(-2,s)*
            A1 * B1 * exp(-B1 /s);
            end;
           if ((j>(MaxTaons-40)) and (j<=(MaxTaons-20))) then
            if MainForm.CheckBox2.Checked then
            Xia := Xia
            else
            Xia := Xia +
            GT*Minus(i,j) * (Xo[i]-Xo[j])/s * A2* (pa23+pb2+pc2+pd2);
           if (j>(MaxTaons-20)) then
            if MainForm.CheckBox3.Checked then
            Xia := Xia
            else
            Xia := Xia +
            GT*Minus(i,j) * (Xo[i]-Xo[j])/s * A3* (pa23+pb3+pc3+pd3);
       end;  //3
    end;  //2
    XUsko:=Xia;
end;  //1
function YUsko(im:integer):extended;
   // Poluchaem uskorenie po osi Y
   var j :integer;
       Yia :extended;
       pa23,pb2,pc2,pd2,pb3,pc3,pd3,s :extended;
   begin //1
   Yia:=0;

   for j:=1 to MaxTaons do
    if Dao[j] then
     if j<>i then
      begin //2
      s := Sqrt(Sqr(Xo[i]-Xo[j])+Sqr(Yo[i]-Yo[j])+Sqr(Zo[i]-Zo[j]));

      pa23:=-GT*(0.945/0.1)*St(18,(0.945/0.1)*s)* (1+19*ln((0.945/0.1)*s))*St(-St(19,(0.945/0.1)*s),(0.945/0.1)*s)
      -125*St(-14,10)*(2.7/30)*75*St(-2,(2.7/30)*s)*(1-ln((2.7/30)*s))*St(75*St(-1,(2.7/30)*s),(2.7/30)*s);

      pb2:=-( St(-1,0.1*1.029/B2)* St(-2,s)*(2.5- St(20,1.029/B2*s))*(1-ln(1.029/B2*s))-200*1.029/B2*St(18,1.029/B2*s)
      *ln(1.029/B2*s))*St((2.5-St(20,1.029/B2*s))*St(-1,0.1*1.029/B2*s),1.029/B2*s);
      pc2:=-( St(-1,0.1*1.029/C2)* St(-2,s)*(2.5- St(20,1.029/C2*s))*(1-ln(1.029/C2*s))-200*1.029/C2*St(18,1.029/C2*s)
      *ln(1.029/C2*s))*St((2.5-St(20,1.029/C2*s))*St(-1,0.1*1.029/C2*s),1.029/C2*s);
      pd2:=-( St(-1,0.1*1.029/D2)* St(-2,s)*(2.5- St(20,1.029/D2*s))*(1-ln(1.029/D2*s))-200*1.029/D2*St(18,1.029/D2*s)
      *ln(1.029/D2*s))*St((2.5-St(20,1.029/D2*s))*St(-1,0.1*1.029/D2*s),1.029/D2*s);

      pb3:=-( St(-1,0.1*1.029/B3)* St(-2,s)*(2.5- St(20,1.029/B3*s))*(1-ln(1.029/B3*s))-200*1.029/B3*St(18,1.029/B3*s)
      *ln(1.029/B3*s))*St((2.5-St(20,1.029/B3*s))*St(-1,0.1*1.029/B3*s),1.029/B3*s);
      pc3:=-( St(-1,0.1*1.029/C3)* St(-2,s)*(2.5- St(20,1.029/C3*s))*(1-ln(1.029/C3*s))-200*1.029/C3*St(18,1.029/C3*s)
      *ln(1.029/C3*s))*St((2.5-St(20,1.029/C3*s))*St(-1,0.1*1.029/C3*s),1.029/C3*s);
      pd3:=-( St(-1,0.1*1.029/D3)* St(-2,s)*(2.5- St(20,1.029/D3*s))*(1-ln(1.029/D3*s))-200*1.029/D3*St(18,1.029/D3*s)
      *ln(1.029/D3*s))*St((2.5-St(20,1.029/D3*s))*St(-1,0.1*1.029/D3*s),1.029/D3*s);

       begin   //3
           if (j<=(MaxTaons-40)) then
            if MainForm.CheckBox1.Checked then
            Yia := Yia
            else
            begin
           if MainForm.CheckBox4.Checked then
            Yia := Yia -
            GT*Minus(i,j) * (Yo[i]-Yo[j])/s *St(-2,s)*
            A1 * B1 *St(B1 / s,s) *(1-ln(s))
            else
            Yia := Yia +
            GT*Minus(i,j) * (Yo[i]-Yo[j])/s *St(-2,s)*
            A1 * B1 * exp(-B1 /s);
            end;
           if ((j>(MaxTaons-40)) and (j<=(MaxTaons-20))) then
            if MainForm.CheckBox2.Checked then
            Yia := Yia
            else
            Yia := Yia +
            GT*Minus(i,j) * (Yo[i]-Yo[j])/s * A2* (pa23+pb2+pc2+pd2);
           if (j>(MaxTaons-20)) then
            if MainForm.CheckBox3.Checked then
            Yia := Yia
            else
            Yia := Yia +
            GT*Minus(i,j) * (Yo[i]-Yo[j])/s * A3* (pa23+pb3+pc3+pd3);
       end;  //3
    end;  //2
    YUsko:=Yia;
end;  //1
function ZUsko(im:integer):extended;
   // Poluchaem uskorenie po osi Z
   var j :integer;
       Zia :extended;
       pa23,pb2,pc2,pd2,pb3,pc3,pd3,s :extended;
   begin //1
   Zia:=0;

   for j:=1 to MaxTaons do
    if Dao[j] then
     if j<>i then
      begin //2
      s := Sqrt(Sqr(Xo[i]-Xo[j])+Sqr(Yo[i]-Yo[j])+Sqr(Zo[i]-Zo[j]));

      pa23:=-GT*(0.945/0.1)*St(18,(0.945/0.1)*s)* (1+19*ln((0.945/0.1)*s))*St(-St(19,(0.945/0.1)*s),(0.945/0.1)*s)
      -125*St(-14,10)*(2.7/30)*75*St(-2,(2.7/30)*s)*(1-ln((2.7/30)*s))*St(75*St(-1,(2.7/30)*s),(2.7/30)*s);

      pb2:=-( St(-1,0.1*1.029/B2)* St(-2,s)*(2.5- St(20,1.029/B2*s))*(1-ln(1.029/B2*s))-200*1.029/B2*St(18,1.029/B2*s)
      *ln(1.029/B2*s))*St((2.5-St(20,1.029/B2*s))*St(-1,0.1*1.029/B2*s),1.029/B2*s);
      pc2:=-( St(-1,0.1*1.029/C2)* St(-2,s)*(2.5- St(20,1.029/C2*s))*(1-ln(1.029/C2*s))-200*1.029/C2*St(18,1.029/C2*s)
      *ln(1.029/C2*s))*St((2.5-St(20,1.029/C2*s))*St(-1,0.1*1.029/C2*s),1.029/C2*s);
      pd2:=-( St(-1,0.1*1.029/D2)* St(-2,s)*(2.5- St(20,1.029/D2*s))*(1-ln(1.029/D2*s))-200*1.029/D2*St(18,1.029/D2*s)
      *ln(1.029/D2*s))*St((2.5-St(20,1.029/D2*s))*St(-1,0.1*1.029/D2*s),1.029/D2*s);

      pb3:=-( St(-1,0.1*1.029/B3)* St(-2,s)*(2.5- St(20,1.029/B3*s))*(1-ln(1.029/B3*s))-200*1.029/B3*St(18,1.029/B3*s)
      *ln(1.029/B3*s))*St((2.5-St(20,1.029/B3*s))*St(-1,0.1*1.029/B3*s),1.029/B3*s);
      pc3:=-( St(-1,0.1*1.029/C3)* St(-2,s)*(2.5- St(20,1.029/C3*s))*(1-ln(1.029/C3*s))-200*1.029/C3*St(18,1.029/C3*s)
      *ln(1.029/C3*s))*St((2.5-St(20,1.029/C3*s))*St(-1,0.1*1.029/C3*s),1.029/C3*s);
      pd3:=-( St(-1,0.1*1.029/D3)* St(-2,s)*(2.5- St(20,1.029/D3*s))*(1-ln(1.029/D3*s))-200*1.029/D3*St(18,1.029/D3*s)
      *ln(1.029/D3*s))*St((2.5-St(20,1.029/D3*s))*St(-1,0.1*1.029/D3*s),1.029/D3*s);

       begin   //3
           if (j<=(MaxTaons-40)) then
            if MainForm.CheckBox1.Checked then
            Zia := Zia
            else
            begin
           if MainForm.CheckBox4.Checked then
            Zia := Zia -
            GT*Minus(i,j) * (Zo[i]-Zo[j])/s *St(-2,s)*
            A1 * B1 *St(B1 / s,s) *(1-ln(s))
            else
            Zia := Zia +
            GT*Minus(i,j) * (Zo[i]-Zo[j])/s *St(-2,s)*
            A1 * B1 * exp(-B1 /s);
            end;
           if ((j>(MaxTaons-40)) and (j<=(MaxTaons-20))) then
            if MainForm.CheckBox2.Checked then
            Zia := Zia
            else
            Zia := Zia +
            GT*Minus(i,j) * (Zo[i]-Zo[j])/s * A2* (pa23+pb2+pc2+pd2);
           if (j>(MaxTaons-20)) then
            if MainForm.CheckBox3.Checked then
            Zia := Zia
            else
            Zia := Zia +
            GT*Minus(i,j) * (Zo[i]-Zo[j])/s * A3* (pa23+pb3+pc3+pd3);
       end;  //3
    end;  //2
    ZUsko:=Zia;
end;  //1

begin // Game //
repeat
   inc(Num);
   begin
         if MainForm.Blockade.Checked  then
         begin     //3
//******************************************
   // Calculation of new value of koord and velo.
             for i:=1 to MaxTaons do
             if Dao[i] then
             if ((i<>16) and (i<>17) and (i<>18) and (i<>19) and (i<>20) and (i<>40) and (i<>60)) then
             begin        //4
       // X
             dXv := XUsko(i) * dt;    // + velo
             Vn[i] := Vn[i] + dXv;    // New x velo
             dX := Vn[i] * dt;        // + koord
              Xn[i] := Xn[i] + dX;     // New koordinat

       // Y
              dYv := YUsko(i) * dt;    // + velo
              Un[i] := Un[i] + dYv;    // New x velo
              dY := Un[i] * dt;        // + koord
              Yn[i] := Yn[i] + dY;     // New koordinat

       // Z
              dZv := ZUsko(i) * dt;    // + velo
              Wn[i] := Wn[i] + dZv;    // New x velo
              dZ := Wn[i] * dt;        // + koord
              Zn[i] := Zn[i] + dZ;     // New koordinat
              end;       //4


   // The new value send to Xo and Vo
              for i:=1 to MaxTaons do
              if Dao[i] then
             if ((i<>16) and (i<>17) and (i<>18) and (i<>19) and (i<>20) and (i<>40) and (i<>60)) then
              begin           //4
              Xo[i]:=Xn[i]; Vo[i]:=Vn[i];
              Yo[i]:=Yn[i]; Uo[i]:=Un[i];
              Zo[i]:=Zn[i]; Wo[i]:=Wn[i];
              x[i]:=Xn[i];
              y[i]:=Yn[i];
              z[i]:=Zn[i];
              end;            //4
//********************************
         end         //3
     else
         begin       //3
   // Calculation of new value of koord and velo.
             for i:=1 to MaxTaons do
             if Dao[i] then
             begin        //4
       // X
             dXv := XUsko(i) * dt;    // + velo
             Vn[i] := Vn[i] + dXv;    // New x velo
             dX := Vn[i] * dt;        // + koord
              Xn[i] := Xn[i] + dX;     // New koordinat

       // Y
              dYv := YUsko(i) * dt;    // + velo
              Un[i] := Un[i] + dYv;    // New x velo
              dY := Un[i] * dt;        // + koord
              Yn[i] := Yn[i] + dY;     // New koordinat

       // Z
              dZv := ZUsko(i) * dt;    // + velo
              Wn[i] := Wn[i] + dZv;    // New x velo
              dZ := Wn[i] * dt;        // + koord
              Zn[i] := Zn[i] + dZ;     // New koordinat
              end;       //4


   // The new value send to Xo and Vo
              for i:=1 to MaxTaons do
              if Dao[i] then
              begin           //4
              Xo[i]:=Xn[i]; Vo[i]:=Vn[i];
             Yo[i]:=Yn[i]; Uo[i]:=Un[i];
              Zo[i]:=Zn[i]; Wo[i]:=Wn[i];
              x[i]:=Xn[i];
              y[i]:=Yn[i];
              z[i]:=Zn[i];
              end;            //4
         end;          //3
   end;
   Time:=Num;
   if ShowLabelTime then
      MainForm.LTime.Caption:=IntToStr(Time);
   DrawLine;
     begin
     if MainForm.ShowList.Checked then
     ShowTable;
     end;
   //
   Application.ProcessMessages;
until Stop;
end;//Game;
// End of graphical proc

procedure TMainForm.Exit1Click(Sender: TObject);
begin
Close
end;

procedure TMainForm.FormPaint(Sender: TObject);
begin
     u0:=Round(width/2);v0:=Round(Pan.Top/2);
     if Spiral
        then
            begin
            ShowSpiral;
            end
        else
            begin
            ThisName:=StartFile;
            DrawLine;
            ShowTable;
            end;
end;

procedure TMainForm.TimerTimer(Sender: TObject);
begin
if Spin then
     if Spiral
        then ShowSpiral
        else DrawLine;
end;

procedure TMainForm.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if Button = mbRight
   then
       begin
       RStartX:=X;
       RStartY:=Y;
       end
   else
       begin
       LStartX:=X;
       LStartY:=Y;
       end;
end;

procedure TMainForm.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if Button = mbRight
   then
       begin
       if RStartX<X then k:=k-KoUgol*(X-RStartX);
       if RStartX>X then k:=k+KoUgol*(RStartX-X);
       if RStartY<Y then xl:=xl-KoRass*(Y-RStartY);
       if RStartY>Y then xl:=xl+KoRass*(RStartY-Y);
       end
   else
       begin
       if LStartX<X then l:=l-KoUgol*(X-LStartX);
       if LStartX>X then l:=l+KoUgol*(LStartX-X);
       if LStartY<Y then j:=j+KoUgol*(Y-LStartY);
       if LStartY>Y then j:=j-KoUgol*(LStartY-Y);
       end;
     if Spiral
        then ShowSpiral
        else
            begin
            if Button = mbRight
               then
                   begin
                   ks:=ks+k;
                   end
               else
                   begin
                   ls:=ls+l;
                   js:=js+j;
                   end;
            DrawLine;
            k:=0;l:=0;j:=0;
            end;
  if not ShowSpin.Checked then begin k:=0;l:=0;j:=0 end;
end;

procedure TMainForm.ShowSpinClick(Sender: TObject);
begin
if ShowSpin.Checked
   then
       begin
       Spin:=false;
       ShowSpin.Checked:=false;
       end
   else
       begin
       Spin:=true;
       ShowSpin.Checked:=true;
       end
end;

procedure TMainForm.FormCreate(Sender: TObject);
var n:integer;
begin
     u0:=Round(width/2);v0:=Round(Pan.Top/2);
     xl:=120;
     j:=0;k:=0;l:=0;
     Spiral:=true;
     //Power:=false;
     MaxTaons:=MaxPunkt;
     TypeSpiral:=1;
     fsincos;
     AssignFile(FStartFile,'C:\Start.dryf');
     {$I-}
     Reset(FStartFile);
     {$I+}
     if IOResult=0
        then
            begin
            Read(FStartFile,StartFile);
            CloseFile(FStartFile);
            if StartFile=''
               then
                   begin
                   CreateFigure;
                   ThisName:='ThetraSpiral';
                   end
               else
                   begin
                   Spiral:=false;
                   Go.Enabled:=true;
                   ThisName:=StartFile;
                   FName.Text:=ThisName;
                   AssignFile(FTaons,ThisName);
                   {$I-}
                   Reset(FTaons);
                   {$I+}
                   if IOResult=0 then
                   begin
                   Read(FTaons, Taons);
                   CloseFile(FTaons);
                   // Write data of taons
                   dt:=Taons.dt;
                   A1:=Taons.A1;
                   B1:=Taons.B1;
                   A2:=Taons.A2;
                   B2:=Taons.B2;
                   C2:=Taons.C2;
                   D2:=Taons.D2;
                   A3:=Taons.A3;
                   B3:=Taons.B3;
                   C3:=Taons.C3;
                   D3:=Taons.D3;
                   for n:=1 to MaxTaons do
                       Dao[n]:=Taons.Dao[n];
                   for n:=1 to MaxTaons do
                       begin
                       Xo[n]:=Taons.Xo[n];
                       Yo[n]:=Taons.Yo[n];
                       Zo[n]:=Taons.Zo[n];
                       Vo[n]:=Taons.Vo[n];
                       Uo[n]:=Taons.Uo[n];
                       Wo[n]:=Taons.Wo[n];

                       x[n]:=Xo[n];Xn[n]:=Xo[n];
                       y[n]:=Yo[n];Yn[n]:=Yo[n];
                       z[n]:=Zo[n];Zn[n]:=Zo[n];
                       Vn[n]:=Vo[n];
                       Un[n]:=Uo[n];
                       Wn[n]:=Wo[n];
                       end;
                   // Commentary
                   n:=Length(ThisName);
                   Delete(ThisName,n-3,4);
                   AssignFile(FTaonsText, ThisName+'.txt');
                   {$I-} Reset(FTaonsText); {$I+}
                   if IOResult=0 then
                      begin
                          CloseFile(FTaonsText);
                          Comment.Lines.LoadFromFile(ThisName+'.txt');
                      end;
                   // End commentary
                   end
                   else
                       begin
                       CreateFigure;
                       FName.Text:='The easy square';
                       end
                   end
            end
        else
            begin
            Rewrite(FStartFile);
            CloseFile(FStartFile);
            CreateFigure;
            ThisName:='ThetraSpiral';
            end;
     KoBok:=5;
     KoRass:=3;
     KoUgol:=0.01;
     ShowTable;
     EditDT.Text:=FloatToStr(dt);
     EditA1.Text:=FloatToStr(A1);
     EditB1.Text:=FloatToStr(B1);
     EditA2.Text:=FloatToStr(A2);
     EditB2.Text:=FloatToStr(B2);
     EditC2.Text:=FloatToStr(C2);
     EditD2.Text:=FloatToStr(D2);
     EditA3.Text:=FloatToStr(A3);
     EditB3.Text:=FloatToStr(B3);
     EditC3.Text:=FloatToStr(C3);
     EditD3.Text:=FloatToStr(D3);

     Stop:=true;
end;

procedure TMainForm.FormResize(Sender: TObject);
var r:integer;
begin
     u0:=Round(width/2);v0:=Round(Pan.Top/2);
     r:=Panel1.Left-5;
     FName.Width:=r+3;
     Comment.Height:=PageControl.Height-29;
     Comment.Width:=r+3;
     PageControl.Width:=r;
     DaonsTable.Width:=r-2;
     DaonsTable.DefaultColWidth:=(r-30) div 6;
     if Spiral
        then ShowSpiral
        else DrawLine;
end;

procedure TMainForm.DaoTeta1Click(Sender: TObject);
begin
     j:=j+KoUgol;
     if Spiral
        then ShowSpiral
        else
            begin
            js:=js+j;
            DrawLine;
            end;
     j:=0;
end;

procedure TMainForm.DaoTetaClick(Sender: TObject);
begin
     j:=j-KoUgol;
     if Spiral
        then ShowSpiral
        else
            begin
            js:=js+j;
            DrawLine;
            end;
     j:=0;
end;

procedure TMainForm.DaoPsiClick(Sender: TObject);
begin
     k:=k-KoUgol;
     if Spiral
        then ShowSpiral
        else
            begin
            ks:=ks+k;
            DrawLine;
            end;
     k:=0;
end;

procedure TMainForm.DaoPsi1Click(Sender: TObject);
begin
     k:=k+KoUgol;
     if Spiral
        then ShowSpiral
        else
            begin
            ks:=ks+k;
            DrawLine;
            end;
     k:=0;
end;

procedure TMainForm.DaoStopClick(Sender: TObject);
begin
     k:=0;j:=0;l:=0;
     if Spiral
        then ShowSpiral
        else DrawLine;
end;

procedure TMainForm.DaoPhi1Click(Sender: TObject);
begin
     l:=l-KoUgol;
     if Spiral
        then ShowSpiral
        else
            begin
            ls:=ls+l;
            DrawLine;
            end;
     l:=0;
end;

procedure TMainForm.DaoPhiClick(Sender: TObject);
begin
     l:=l+KoUgol;
     if Spiral
        then ShowSpiral
        else
            begin
            ls:=ls+l;
            DrawLine;
            end;
     l:=0;
end;

procedure TMainForm.DaoBackClick(Sender: TObject);
begin
     if xl < 9*KoRass
        then xl:=xl/KoRass
        else xl:=xl-KoRass*3;
     if Spiral
        then ShowSpiral
        else DrawLine;
end;

procedure TMainForm.DaoForvardClick(Sender: TObject);
begin
     xl:=xl+KoRass*3;
     if Spiral
        then ShowSpiral
        else DrawLine;
end;

procedure TMainForm.TrackBarChange(Sender: TObject);
begin
case TrackBar.Position of
     0:KoUgol:=0.0005;
     1:KoUgol:=0.001;
     2:KoUgol:=0.002;
     3:KoUgol:=0.003;
     4:KoUgol:=0.005;
     5:KoUgol:=0.01;
     6:KoUgol:=0.05;
     7:KoUgol:=0.1;
     8:KoUgol:=0.5;
     9:KoUgol:=1;
     10:KoUgol:=2;
     end;
case TrackBar.Position of
     0:KoRass:=0.5;
     1:KoRass:=1;
     2:KoRass:=2;
     3:KoRass:=3;
     4:KoRass:=5;
     5:KoRass:=7;
     6:KoRass:=10;
     7:KoRass:=15;
     8:KoRass:=20;
     9:KoRass:=30;
     10:KoRass:=50;
     end;
end;

procedure TMainForm.ShowNumbersOfPointsClick(Sender: TObject);
begin
if ShowNumbersOfPoints.Checked
   then
       begin
       ShowNumbersOfPunkts:=false;
       ShowNumbersOfPoints.Checked:=false;
       end
   else
       begin
       ShowNumbersOfPunkts:=true;
       ShowNumbersOfPoints.Checked:=true;
       end;
if Spiral
   then ShowSpiral
   else DrawLine;
end;

procedure TMainForm.Spiral1Click(Sender: TObject);
begin
     Spiral:=true;
     CreateFigure;
     Go.Enabled:=false;
     ShowSpiral;
end;

procedure TMainForm.Daons1Click(Sender: TObject);
var n:integer;
begin
     Spiral:=false;
     Go.Enabled:=true;
     {$I-}
     Reset(FStartFile);
     {$I+}
     if IOResult=0
        then
            begin
            Read(FStartFile,StartFile);
            CloseFile(FStartFile);
            if StartFile=''
               then
                   begin
                   CreateFigure;
                   ThisName:='This is a stabil structur of taons';
                   CreateFigure;
                   ShowTable;
                   FName.Text:=ThisName;
                   DrawLine;
                   end
               else
                   begin
                   Spiral:=false;
                   ThisName:=StartFile;
                   FName.Text:=ThisName;
                   AssignFile(FTaons,ThisName);
                   {$I-}
                   Reset(FTaons);
                   {$I+}
                   if IOResult=0 then
                   begin
                   Read(FTaons, Taons);
                   CloseFile(FTaons);
                   // Write data of taons
                   dt:=Taons.dt;
                   A1:=Taons.A1;
                   B1:=Taons.B1;
                   A2:=Taons.A2;
                   B2:=Taons.B2;
                   C2:=Taons.C2;
                   D2:=Taons.D2;
                   A3:=Taons.A3;
                   B3:=Taons.B3;
                   C3:=Taons.C3;
                   D3:=Taons.D3;
                   for n:=1 to MaxTaons do
                       Dao[n]:=Taons.Dao[n];
                   for n:=1 to MaxTaons do
                       begin
                       Xo[n]:=Taons.Xo[n];
                       Yo[n]:=Taons.Yo[n];
                       Zo[n]:=Taons.Zo[n];
                       Vo[n]:=Taons.Vo[n];
                       Uo[n]:=Taons.Uo[n];
                       Wo[n]:=Taons.Wo[n];

                       x[n]:=Xo[n];Xn[n]:=Xo[n];
                       y[n]:=Yo[n];Yn[n]:=Yo[n];
                       z[n]:=Zo[n];Zn[n]:=Zo[n];
                       Vn[n]:=Vo[n];
                       Un[n]:=Uo[n];
                       Wn[n]:=Wo[n];
                       end;
                   DrawLine;
                   ShowTable;
                   end
                   else
                       begin
                       CreateFigure;
                       end
                   end
            end
        else
            MessageDlg('The start File not found.', mtInformation, [mbOk], 0);
end;

procedure TMainForm.Left1Click(Sender: TObject);
begin
     xt:=xt-KoBok;
     if Spiral
        then ShowSpiral
        else DrawLine;
end;

procedure TMainForm.Right1Click(Sender: TObject);
begin
     xt:=xt+KoBok;
     if Spiral
        then ShowSpiral
        else DrawLine;
end;

procedure TMainForm.Up1Click(Sender: TObject);
begin
     zt:=zt-KoBok;
     if Spiral
        then ShowSpiral
        else DrawLine;
end;

procedure TMainForm.Down1Click(Sender: TObject);
begin
     zt:=zt+KoBok;
     if Spiral
        then ShowSpiral
        else DrawLine;
end;

procedure TMainForm.GoClick(Sender: TObject);
begin
if not Stop
   then
       begin
       Go.Kind:=bkOK;
       Go.Caption:='Go';
       ShapeRed.Brush.Color:=clMaroon;
       ShapeLime.Brush.Color:=clLime;
       Stop:=true;
       Images.Enabled:=true;
       end
   else
       begin
       Go.Kind:=bkCancel;
       Go.Caption:='Stop';
       ShapeRed.Brush.Color:=clRed;
       ShapeLime.Brush.Color:=clGreen;
       Stop:=false;
       Images.Enabled:=false;
       Game(Time);
       end;
end;

procedure TMainForm.DaonsTableDblClick(Sender: TObject);
begin
VeloCity:=not VeloCity; ShowTable;
end;

procedure TMainForm.New1Click(Sender: TObject);
begin
if EditDlg.ShowModal = mrOK then
   begin
   Spiral:=false;
   Go.Enabled:=true;
   FName.Text:=ThisName;
   Time:=0; LTime.Caption:='0';
   // Show result
   DrawLine;
   ShowTable;
   EditDT.Text:=FloatToStr(dt);
   EditA1.Text:=FloatToStr(A1);
   EditB1.Text:=FloatToStr(B1);
   EditA2.Text:=FloatToStr(A2);
   EditB2.Text:=FloatToStr(B2);
   EditC2.Text:=FloatToStr(C2);
   EditD2.Text:=FloatToStr(D2);
   EditA3.Text:=FloatToStr(A3);
   EditB3.Text:=FloatToStr(B3);
   EditC3.Text:=FloatToStr(C3);
   EditD3.Text:=FloatToStr(D3);

   //
   end;
end;

procedure TMainForm.Open1Click(Sender: TObject);
var n:integer;
begin
if OpenDialog.Execute then
   begin
   Spiral:=false;
   Go.Enabled:=true;
   ThisName:=OpenDialog.FileName;
   FName.Text:=ThisName;
   AssignFile(FTaons,OpenDialog.FileName);
   Reset(FTaons);
   Read(FTaons, Taons);
   CloseFile(FTaons);
   StartFile:=ThisName;
   Rewrite(FStartFile);
   Write(FStartFile, StartFile);
   CloseFile(FStartFile);
   // Write data of taons
   dt:=Taons.dt;
   A1:=Taons.A1;
   B1:=Taons.B1;
   A2:=Taons.A2;
   B2:=Taons.B2;
   C2:=Taons.C2;
   D2:=Taons.D2;
   A3:=Taons.A3;
   B3:=Taons.B3;
   C3:=Taons.C3;
   D3:=Taons.D3;
   for n:=1 to MaxTaons do
       Dao[n]:=Taons.Dao[n];
   for n:=1 to MaxTaons do
       begin
       Xo[n]:=Taons.Xo[n];
       Yo[n]:=Taons.Yo[n];
       Zo[n]:=Taons.Zo[n];
       Vo[n]:=Taons.Vo[n];
       Uo[n]:=Taons.Uo[n];
       Wo[n]:=Taons.Wo[n];

       x[n]:=Xo[n];Xn[n]:=Xo[n];
       y[n]:=Yo[n];Yn[n]:=Yo[n];
       z[n]:=Zo[n];Zn[n]:=Zo[n];
       Vn[n]:=Vo[n];
       Un[n]:=Uo[n];
       Wn[n]:=Wo[n];
       end;
   // Show result
   Time:=0; LTime.Caption:='0';
   DrawLine;
   ShowTable;
   EditDT.Text:=FloatToStr(dt);
   EditA1.Text:=FloatToStr(A1);
   EditB1.Text:=FloatToStr(B1);
   EditA2.Text:=FloatToStr(A2);
   EditB2.Text:=FloatToStr(B2);
   EditC2.Text:=FloatToStr(C2);
   EditD2.Text:=FloatToStr(D2);
   EditA3.Text:=FloatToStr(A3);
   EditB3.Text:=FloatToStr(B3);
   EditC3.Text:=FloatToStr(C3);
   EditD3.Text:=FloatToStr(D3);
   //
   // Commentary
   n:=Length(ThisName);
   Delete(ThisName,n-3,4);
   AssignFile(FTaonsText, ThisName+'.txt');
   {$I-}
   Reset(FTaonsText);
   {$I+}
   if IOResult=0 then
      begin
      CloseFile(FTaonsText);
      Comment.Lines.LoadFromFile(ThisName+'.txt');
      end;
   // End commentary
   end;
end;

procedure TMainForm.Save1Click(Sender: TObject);
begin
if not Spiral then
   begin
   SaveDataOfTaons;
   AssignFile(FTaons, ThisName);
   Rewrite(FTaons);
   Write(FTaons, Taons);
   CloseFile(FTaons);
   end;
end;

procedure TMainForm.Saveas1Click(Sender: TObject);
begin
if not Spiral then
if SaveDialog.Execute then
   begin
   ThisName:=SaveDialog.FileName;
   FName.Text:=ThisName;
   SaveDataOfTaons;
   AssignFile(FTaons,SaveDialog.FileName);
   Rewrite(FTaons);
   Write(FTaons, Taons);
   CloseFile(FTaons);
   StartFile:=ThisName;
   {$I-}
   Rewrite(FStartFile);
   {$I+}
   Write(FStartFile,StartFile);
   CloseFile(FStartFile);
   end;
end;

procedure TMainForm.MoveToCenterClick(Sender: TObject);
begin
xl:=120;
xt:=0;zt:=0;
if Spiral
   then ShowSpiral
   else DrawLine;
end;

procedure TMainForm.CommentChange(Sender: TObject);
begin
EditComm:=true;
end;

procedure TMainForm.CommentExit(Sender: TObject);
var n:integer;
begin
if EditComm then
   begin
   EditComm:=false;
   if MessageDlg('The text was changed. Save now?',
      mtConfirmation, [mbYes, mbNo], 0) = mrYes then
      begin
      n:=Length(ThisName);
      Delete(ThisName,n-3,4);
      AssignFile(FTaonsText, ThisName+'.txt');
      Rewrite(FTaonsText);
      //Write(FTaonsText, '');
      CloseFile(FTaonsText);
      Comment.Lines.SaveToFile(ThisName+'.txt');
      //Comment.Lines.LoadFromFile(ThisName);
      end
   end
end;

procedure TMainForm.About1Click(Sender: TObject);
begin
AboutBox.ShowModal;
end;

procedure TMainForm.RusHelpClick(Sender: TObject);
  begin
    if MainForm.Taoscope.Checked then
     Application.HelpFile := 'HlpArtRu.hlp';
     Application.HelpCommand(HELP_CONTENTS, 0);

    if MainForm.Gravoscope.Checked then
     Application.HelpFile := 'HlpArtRu.hlp';
     Application.HelpCommand(HELP_CONTENTS, 0);
  end;

procedure TMainForm.PolHelpClick(Sender: TObject);
  begin
    if MainForm.Taoscope.Checked then
       Application.HelpFile := 'HlpArtPl.hlp';
       Application.HelpCommand(HELP_CONTENTS, 0);

    if MainForm.Gravoscope.Checked then
       Application.HelpFile := 'HlpArtPl.hlp';
       Application.HelpCommand(HELP_CONTENTS, 0);
  end;

procedure TMainForm.EditDTKeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TMainForm.EditCzasKeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TMainForm.EditA1KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TMainForm.EditB1KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TMainForm.EditA2KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TMainForm.EditB2KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;
procedure TMainForm.EditC2KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;
procedure TMainForm.EditD2KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;
procedure TMainForm.EditA3KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TMainForm.EditB3KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;
procedure TMainForm.EditC3KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;
procedure TMainForm.EditD3KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TMainForm.EditDTExit(Sender: TObject);
begin
dt:=StrToFloat(EditDT.Text);
end;

procedure TMainForm.EditA1Exit(Sender: TObject);
begin
A1:=StrToFloat(EditA1.Text);
end;

procedure TMainForm.EditB1Exit(Sender: TObject);
begin
B1:=StrToFloat(EditB1.Text);
end;

procedure TMainForm.EditA2Exit(Sender: TObject);
begin
A2:=StrToFloat(EditA2.Text);
end;

procedure TMainForm.EditB2Exit(Sender: TObject);
begin
B2:=StrToFloat(EditB2.Text);
end;
procedure TMainForm.EditC2Exit(Sender: TObject);
begin
C2:=StrToFloat(EditC2.Text);
end;
procedure TMainForm.EditD2Exit(Sender: TObject);
begin
D2:=StrToFloat(EditD2.Text);
end;
procedure TMainForm.EditA3Exit(Sender: TObject);
begin
A3:=StrToFloat(EditA3.Text);
end;
procedure TMainForm.EditB3Exit(Sender: TObject);
begin
B3:=StrToFloat(EditB3.Text);
end;
procedure TMainForm.EditC3Exit(Sender: TObject);
begin
C3:=StrToFloat(EditC3.Text);
end;
procedure TMainForm.EditD3Exit(Sender: TObject);
begin
D3:=StrToFloat(EditD3.Text);
end;

procedure TMainForm.Null00Click(Sender: TObject);
var i:integer;
begin
if not Spiral then
if Stop then
   begin
   for i:=1 to MaxTaons do
       begin
       Vo[i]:=0;Uo[i]:=0;Wo[i]:=0;
       Vn[i]:=0;Un[i]:=0;Wn[i]:=0;
       end;
   ShowTable;
   if SaveDialog.Execute then
      begin
      ThisName:=SaveDialog.FileName;
      FName.Text:=ThisName;
      SaveDataOfTaons;
      AssignFile(FTaons,SaveDialog.FileName);
      Rewrite(FTaons);
      Write(FTaons, Taons);
      CloseFile(FTaons);
      StartFile:=ThisName;
      {$I-}
      Rewrite(FStartFile);
      {$I+}
      Write(FStartFile,StartFile);
      CloseFile(FStartFile);
      end;
   end
end;

procedure TMainForm.LTimeDblClick(Sender: TObject);
begin
ShowLabelTime := not ShowLabelTime;
end;

end.
